

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

Structure describing the #GstStaticPadTemplate.
-}

module GI.Gst.Structs.StaticPadTemplate
    ( 

-- * Exported types
    StaticPadTemplate(..)                   ,
    newZeroStaticPadTemplate                ,
    noStaticPadTemplate                     ,


 -- * Methods
-- ** staticPadTemplateGet
    StaticPadTemplateGetMethodInfo          ,
    staticPadTemplateGet                    ,


-- ** staticPadTemplateGetCaps
    StaticPadTemplateGetCapsMethodInfo      ,
    staticPadTemplateGetCaps                ,




 -- * Properties
-- ** Direction
    staticPadTemplateReadDirection          ,


-- ** NameTemplate
    staticPadTemplateReadNameTemplate       ,


-- ** Presence
    staticPadTemplateReadPresence           ,


-- ** StaticCaps
    staticPadTemplateReadStaticCaps         ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gst.Types
import GI.Gst.Callbacks

newtype StaticPadTemplate = StaticPadTemplate (ForeignPtr StaticPadTemplate)
-- | Construct a `StaticPadTemplate` struct initialized to zero.
newZeroStaticPadTemplate :: MonadIO m => m StaticPadTemplate
newZeroStaticPadTemplate = liftIO $ callocBytes 64 >>= wrapPtr StaticPadTemplate

noStaticPadTemplate :: Maybe StaticPadTemplate
noStaticPadTemplate = Nothing

staticPadTemplateReadNameTemplate :: StaticPadTemplate -> IO T.Text
staticPadTemplateReadNameTemplate s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CString
    val' <- cstringToText val
    return val'

staticPadTemplateReadDirection :: StaticPadTemplate -> IO PadDirection
staticPadTemplateReadDirection s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO CUInt
    let val' = (toEnum . fromIntegral) val
    return val'

staticPadTemplateReadPresence :: StaticPadTemplate -> IO PadPresence
staticPadTemplateReadPresence s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 12) :: IO CUInt
    let val' = (toEnum . fromIntegral) val
    return val'

staticPadTemplateReadStaticCaps :: StaticPadTemplate -> IO StaticCaps
staticPadTemplateReadStaticCaps s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO (Ptr StaticCaps)
    val' <- (newPtr 48 StaticCaps) val
    return val'

-- method StaticPadTemplate::get
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "_obj", argType = TInterface "Gst" "StaticPadTemplate", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : TInterface "Gst" "PadTemplate"
-- throws : False
-- Skip return : False

foreign import ccall "gst_static_pad_template_get" gst_static_pad_template_get :: 
    Ptr StaticPadTemplate ->                -- _obj : TInterface "Gst" "StaticPadTemplate"
    IO (Ptr PadTemplate)


staticPadTemplateGet ::
    (MonadIO m) =>
    StaticPadTemplate                       -- _obj
    -> m PadTemplate                        -- result
staticPadTemplateGet _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- gst_static_pad_template_get _obj'
    checkUnexpectedReturnNULL "gst_static_pad_template_get" result
    result' <- (wrapObject PadTemplate) result
    touchManagedPtr _obj
    return result'

data StaticPadTemplateGetMethodInfo
instance (signature ~ (m PadTemplate), MonadIO m) => MethodInfo StaticPadTemplateGetMethodInfo StaticPadTemplate signature where
    overloadedMethod _ = staticPadTemplateGet

-- method StaticPadTemplate::get_caps
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "_obj", argType = TInterface "Gst" "StaticPadTemplate", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : TInterface "Gst" "Caps"
-- throws : False
-- Skip return : False

foreign import ccall "gst_static_pad_template_get_caps" gst_static_pad_template_get_caps :: 
    Ptr StaticPadTemplate ->                -- _obj : TInterface "Gst" "StaticPadTemplate"
    IO (Ptr Caps)


staticPadTemplateGetCaps ::
    (MonadIO m) =>
    StaticPadTemplate                       -- _obj
    -> m Caps                               -- result
staticPadTemplateGetCaps _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- gst_static_pad_template_get_caps _obj'
    checkUnexpectedReturnNULL "gst_static_pad_template_get_caps" result
    result' <- (wrapBoxed Caps) result
    touchManagedPtr _obj
    return result'

data StaticPadTemplateGetCapsMethodInfo
instance (signature ~ (m Caps), MonadIO m) => MethodInfo StaticPadTemplateGetCapsMethodInfo StaticPadTemplate signature where
    overloadedMethod _ = staticPadTemplateGetCaps

type family ResolveStaticPadTemplateMethod (t :: Symbol) (o :: *) :: * where
    ResolveStaticPadTemplateMethod "get" o = StaticPadTemplateGetMethodInfo
    ResolveStaticPadTemplateMethod "getCaps" o = StaticPadTemplateGetCapsMethodInfo
    ResolveStaticPadTemplateMethod l o = MethodResolutionFailed l o

instance (info ~ ResolveStaticPadTemplateMethod t StaticPadTemplate, MethodInfo info StaticPadTemplate p) => IsLabelProxy t (StaticPadTemplate -> p) where
    fromLabelProxy _ = overloadedMethod (MethodProxy :: MethodProxy info)

#if MIN_VERSION_base(4,9,0)
instance (info ~ ResolveStaticPadTemplateMethod t StaticPadTemplate, MethodInfo info StaticPadTemplate p) => IsLabel t (StaticPadTemplate -> p) where
    fromLabel _ = overloadedMethod (MethodProxy :: MethodProxy info)
#endif


